<template>
  <v-app dark style="position: relative">
    <Header />
    <nuxt />
    <Footer />
    <div
      v-if="
        totalCart &&
        totalCart > 0 &&
        $route.path !== '/checkout' &&
        $route.path !== '/cart' &&
        $route.path !== '/order-success'
      "
      class="d-flex justify-end align-center menu"
    >
      <button
        class="d-flex align-center justify-center background-cart"
        @click="drawerProduct = !drawerProduct"
      >
        <v-icon size="22px" color="white"> mdi-cart-outline </v-icon>
        <div class="total">{{ totalCart }}</div>
      </button>
    </div>
    <v-navigation-drawer
      v-model="drawerProduct"
      temporary
      fixed
      right
      width="480"
    >
      <div
        class="pb-4 pos-relative product-card fheight d-flex flex-column justify-space-between"
      >
        <div
          class="d-flex align-center justify-space-between md:py-10 py-5 px-7"
          style="border-bottom: 1px solid #e0e0e0"
        >
          <nuxt-link to="/cart" class="text-decoration-none black--text">
            <p class="mb-0 h6" style="font-size: 20px !important">
              {{ $language.yourShoppingCart }}
            </p>
          </nuxt-link>
          <v-btn
            color="#cecece"
            small
            fab
            class="elevation-0"
            @click="drawerProduct = !drawerProduct"
          >
            <v-icon color="#fff"> mdi-close </v-icon>
          </v-btn>
        </div>

        <!-- <v-divider></v-divider> -->
        <div
          :class="totalCart >= 2 ? 'cart ' : ''"
          v-show="listCart && listCart.length"
          class="mt-8 px-sm-7 px-3 sroll-cart-product"
          style="flex: 1 1"
        >
          <div v-for="(product, i) in listCart" :key="i" class="mb-4">
            <div style="width: 100% !important">
              <div class="d-flex" style="width: 100% !important">
                <div
                  class="product-card__image mr-3"
                  style="
										min-width: 127px;
										max-width: 128px;
										height: 128px;
										width: 100%; 1px solid #e8e8e8; border-radius: 5px;
										overflow:hidden
									"
                >
                  <img
                    :src="convertImg(product)"
                    data-priority="false"
                    onload="this.dataset.loaded=true;"
                    onerror="this.dataset.error=true;"
                    data-loaded="true"
                    style="width: 100%; height: 100%"
                  />
                </div>
                <div style="width: 100%">
                  <div class="d-flex justify-space-between">
                    <div style="max-width: 197px">
                      <p class="mb-0 font-weight-bold">
                        {{ product && product.productName }}
                      </p>
                      <!-- <p
                        class="color-main-menu subTitle1 mt-2 fsize-12"
                        v-show="product && product.listValue.length"
                      >
                        {{ product.listValue.join(" / ") }}
                      </p> -->
                      <p
                        class="mb-0 color-main-menu subTitle1 fsize-name-variant"
                        v-for="(variant, i) in Object.keys(product.listVariant)"
                      >
                        <span class="font-weight-bold lightContentPrimary">
                          {{ variant }}</span
                        >: {{ product.listVariant[variant] }}
                      </p>
                    </div>

                    <!-- <p
                        class="mb-0 fsize-12 c-pointer d-flex items-center text-decoration-underline"
                        style="color: #ff4343 !important"
                        @click="onDelete(i)"
                      >
                        {{ $language.removeItem }}
                      </p> -->
                  </div>
                </div>
              </div>
              <div
                class="d-flex align-center flex-wrap justify-space-between mt-3"
              >
                <v-btn color="#242a2e" icon small @click="onDelete(i)">
                  <v-icon color="#242a2e" size="20"> mdi-trash-can </v-icon>
                </v-btn>
                <div
                  class="d-flex flex-wrap align-center add-item border-quantity"
                  style="width: fit-content"
                >
                  <button class="px-2 py-2" @click="onDecrease(product, i)">
                    <v-icon color="#000000" size="16"> mdi-minus </v-icon>
                  </button>
                  <div
                    id="hideBottomInput"
                    class="d-flex justify-center"
                    style="width: 28px"
                  >
                    <p class="mb-0">
                      {{ product.quantity }}
                    </p>
                    <!-- <v-text-field
                          dense
                          outlined
                          v-model.number="product.quantity"
                          class="product-card__input"
                          readonly
                          style="width: 54px"
                        >
                        </v-text-field> -->
                  </div>
                  <button class="px-2 py-2" @click="onIncrease(product, i)">
                    <v-icon color="#000000" size="16"> mdi-plus </v-icon>
                  </button>
                </div>
                <div
                  class="d-flex items-center justify-end mt-3"
                  style="width: 50%"
                >
                  <p class="mb-0" v-show="timer">
                    <span
                      class="text-decoration-line-through fsize-12 mr-1 mb-1"
                      v-show="calcSalePrice(product) !== calcPrice(product)"
                      >${{
                        calcPrice(product) &&
                        $utils.formatCurrency(calcPrice(product))
                      }}</span
                    >
                    ${{
                      timer
                        ? calcSalePrice(product) &&
                          $utils.formatCurrency(calcSalePrice(product))
                        : calcPrice(product) &&
                          $utils.formatCurrency(calcPrice(product))
                    }}
                  </p>
                  <p class="mb-0" v-show="!timer">
                    <span
                      class="text-decoration-line-through fsize-12 mr-1 mb-1"
                      v-show="calcSalePrice(product) !== calcPrice(product)"
                      >${{
                        calcPrice(product) &&
                        $utils.formatCurrency(calcPrice(product))
                      }}</span
                    >
                    <span>
                      ${{
                        calcSalePrice(product) &&
                        $utils.formatCurrency(calcSalePrice(product))
                      }}
                    </span>
                  </p>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="my-4" v-show="listCart && !listCart.length">
          <div class="d-flex align-center justify-center">
            <img
              src="~/assets/images/no-product.webp"
              alt=""
              width="120px"
              height="120px"
            />
          </div>
          <p class="mb-0 fsize-14 mt-5 text-center">
            There are no items in your cart.
          </p>
        </div>
        <div class="pt-4 px-4 part-checkout white">
          <!-- :style="
            $vuetify.breakpoint.name !== 'xs' ||
            $vuetify.breakpoint.name !== 'sm'
              ? 'position: absolute'
              : ''
          " -->
          <v-divider></v-divider>
          <div class="pos-relative">
            <div
              style="
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                z-index: 30;
                background-color: #fff;
                opacity: 0.5;
              "
              class="d-flex align-center justify-center"
              v-if="loading"
            >
              <v-progress-circular
                v-if="loading"
                size="18"
                indeterminate
                color="#000"
              >
              </v-progress-circular>
            </div>
            <div class="pt-4">
              <div v-if="priceDiscount">
                <div class="card-we-have pa-2 fsize-14">
                  <p class="mb-0">
                    {{ $language.wehavesave }}
                  </p>
                </div>
                <div class="d-flex align-center justify-end mt-2">
                  <div class="mr-6">
                    <div class="d-flex align-center">
                      <v-icon size="16"> mdi-tag-outline </v-icon>
                      <p class="ml-1 mb-0 black--text fsize-15 text-right">
                        {{ $language.discount }}
                      </p>
                    </div>
                  </div>
                  <div style="min-width: 70px">
                    <p
                      class="mb-0 font-weight-bold black--text fsize-15 text-right"
                    >
                      <span>-</span>${{
                        priceDiscount && Math.round(priceDiscount * 100) / 100
                      }}
                    </p>
                  </div>
                </div>
              </div>
              <div class="d-flex align-center justify-end mt-2">
                <div class="mr-6">
                  <p class="mb-0 black--text fsize-15 text-right">
                    {{ $language.subtotal }}
                  </p>
                </div>
                <div>
                  <p
                    class="mb-0 font-weight-bold black--text fsize-15 text-right"
                  >
                    ${{
                      $utils.formatCurrency(
                        parseFloat(
                          (parseFloat(totalPrice) - priceDiscount).toFixed(2)
                        )
                      )
                    }}
                  </p>
                </div>
              </div>
              <!-- <div class="d-flex align-center justify-space-between mt-2">
              <div class="mr-6">
                <p class="mb-0 black--text fsize-15">Shipping</p>
              </div>
              <div>
                <p
                  class="mb-0 font-weight-medium black--text fsize-15 text-right"
                >
                  ${{ findGreatThanShipping.price }}
                </p>
              </div>
            </div> -->
              <!-- <div class="d-flex align-center justify-space-between mt-2">
              <div class="mr-6">
                <p class="mb-0 black--text fsize-15 font-weight-bold">Total</p>
              </div>
              <div>
                <p
                  class="mb-0 font-weight-bold black--text fsize-15 text-right"
                >
                  ${{
                    $utils.formatCurrencyFloat(
                      parseFloat(totalPrice).toFixed(2)
                    )
                  }}
                </p>
              </div>
            </div> -->
              <nuxt-link
                :to="`${slug ? `/${slug}` : ''}/checkout`"
                class="text-decoration-none"
              >
                <v-btn
                  color="#1b1b1b"
                  class="elevation-0 mt-2"
                  block
                  height="55"
                  :disabled="loading"
                  style="max-width: 100%"
                  @click="onRedirectCheckOut()"
                >
                  <div class="d-flex align-center">
                    <p class="mb-0 checkout-text-btn fweight-400 white--text">
                      {{ $language.checkout }}
                    </p>
                  </div>
                </v-btn>
              </nuxt-link>
              <div style="position: relative" class="py-3">
                <v-divider class="my-4"></v-divider>
                <span
                  class="px-2 py-1 white"
                  style="
                    position: absolute;
                    top: 50%;
                    left: 50%;
                    transform: translate(-50%, -50%);
                    color: #b5b5b5;
                    font-size: 0.75rem;
                  "
                >
                  or quick checkout with
                </span>
              </div>
              <div
                ref="paypalHeader"
                :style="
                  !loadingPaypal
                    ? 'visibility: visible;  position: relative; z-index: 5'
                    : 'visibility: hidden;'
                "
              ></div>
              <div v-if="isLoadingPaypal">
                <v-btn color="#ffc439" height="44" block class="elevation-0">
                  <v-progress-circular size="18" indeterminate color="#fff">
                  </v-progress-circular>
                </v-btn>
              </div>
            </div>
          </div>
        </div>
      </div>
    </v-navigation-drawer>
    <div id="loading-full-page" v-if="loadingFullPage" style="height: 100vh">
      <div class="content">
        <img :src="logo" alt="" />
        <div class="d-flex justify-center mt-2">
          <p class="mb-0" style="color: #6b7280">Loading...</p>
          <v-progress-circular
            class="ml-2 mt-1"
            indeterminate
            size="16"
            color="#6B7280"
          ></v-progress-circular>
        </div>
      </div>
    </div>
    <div id="cart-fixed-bottom" class="d-none">
      <div id="cart-fixed" class="d-block d-sm-none pa-4">
        <div id="hideBottomInput">
          <v-select
            v-if="
              product.listVariantSellerId && product.listVariantSellerId.length
            "
            :menu-props="{ top: true, offsetY: true }"
            debse
            outlined
            placeholder="Select your product variant"
            v-model="variantId"
            :items="product.listVariantSellerId"
            :item-text="getNameVariant"
            item-value="_id"
          ></v-select>
        </div>
        <div class="d-flex align-center mt-2" style="gap: 12px">
          <div
            class="d-flex flex-wrap align-center add-item border-quantity"
            style="width: fit-content; min-width: 95px"
          >
            <button class="px-2 py-2" @click="onDecreaseCart()">
              <v-icon color="#000000" size="16"> mdi-minus </v-icon>
            </button>
            <div
              id="hideBottomInput"
              class="d-flex justify-center"
              style="width: 28px"
            >
              <p class="mb-0">
                {{ quantityProduct }}
              </p>
            </div>
            <button class="px-2 py-2" @click="onIncreaseCart()">
              <v-icon color="#000000" size="16"> mdi-plus </v-icon>
            </button>
          </div>
          <div style="width: 100%">
            <v-btn
              color="#FB5607"
              class="elevation-0"
              block
              height="42px"
              @click="onAddToCart()"
            >
              <div class="d-flex align-center">
                <v-icon color="#fff" size="16"> mdi-cart </v-icon>
                <span class="white--text text-none ml-2"> Add to cart </span>
              </div>
            </v-btn>
          </div>
        </div>
      </div>
    </div>
  </v-app>
</template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import PromotionModule from "~/store/promotion";
import gtag from "~/utils/ads-analytic";
//@ts-ignore
import language from "~/locales/language-product.json";
import { handleTwitter, TwitterTracking } from "~/assets/js/twitter";

import Swal from "sweetalert2";
import { loadScript } from "@paypal/paypal-js";
import {
  trackEventAddPaymentInfo,
  trackEventCheckoutInitiated,
  trackEventPurchased,
} from "~/utils/trackEvent";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { onGetListCart } from "~/utils/localStorage";
import { getSessionId, randomCharacter, setSessionId } from "~/utils/sessionId";
import sitePage from "~/store/sitePage";

@Component({
  components: {
    Header: () => import("@/components/Header/index.vue"),
    Footer: () => import("@/components/Footer/index.vue"),
    paymentPaypal: () => import("@/components/Home/Paypal/index.vue"),
  },
})
export default class DefaultLayout extends Vue {
  siteInfoModule = getModule(sitePage, this.$store);

  get drawerProduct() {
    return this.$store.state.cart.drawerProduct || false;
  }

  set drawerProduct(value: boolean) {
    this.$store.commit("cart/setDrawerProduct", value);
  }

  //   cart = getModule(CartModule, this.$store);
  promotion = getModule(PromotionModule, this.$store);
  loading = false;

  quantityProduct = 1;
  variantId = "";

  get cart() {
    return this.$store.state.cart.cart;
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  convertImg(product: any) {
    if (product?.imageId?.imageUrl) {
      return `${api}/${product.imageId.imageUrl}`;
    }
    return "";
  }
  get totalCart() {
    let count = 0;
    const listCart = this.$store.state.cart.listCart;
    if (listCart && listCart.length) {
      for (let item of listCart) {
        count += item.quantity;
      }
    }
    return count;
  }

  get totalPrice() {
    let price = 0;
    const cart = this.$store.state.cart.listCart;
    if (cart && cart.length) {
      for (let product of cart) {
        price += product.price * product.quantity;
      }
    }
    return price.toFixed(2);
  }
  get $language() {
    if (this.$store.state.product.language.welcomeTo) {
      return this.$store.state.product.language;
    }
    return language.EN;
  }

  get findGreatThanShipping() {
    return this.$store.state.product?.findGreatThanShipping || {};
  }

  get priceDiscount() {
    return this.$store?.state?.product?.priceDiscount || 0;
  }

  calcSalePrice(product: any) {
    return product.price;
  }

  calcPrice(product: any) {
    return product.comparePrice;
  }

  onRedirectCheckOut() {
    this.loading = true;
  }

  onDecreaseCart() {
    if (this.quantityProduct <= 1) return;
    this.quantityProduct -= 1;
    this.$store.commit("product/getPriceShipping", {
      listCart: this.listCart,
      totalP: this.totalPrice,
    });
  }

  onIncreaseCart() {
    this.quantityProduct += 1;
    this.$store.commit("product/getPriceShipping", {
      listCart: this.listCart,
      totalP: this.totalPrice,
    });
  }

  async onApplyCoupon() {
    try {
      let total = 0;
      for (let product of this.listCart) {
        total += product.quantity;
      }
      const body = {
        quantity: total,
        total: parseFloat(this.totalPrice),
        shipping: this.findGreatThanShipping.price || 0,
      };
      await this.$store.dispatch("product/onApplyCoupon", { ctx: this, body });
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onIncrease(variantProduct: any, i: number) {
    this.loading = true;
    const cart = onGetListCart();
    let variant = this.$utils.cloneDeep(variantProduct);
    // const findProduct = cart.find((variant:any) => variant._id === findProduct._id)
    variant.quantity += 1;
    cart[i] = variant;
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", JSON.stringify(cart));
    this.$store.commit("product/getPriceShipping", {
      listCart: this.listCart,
      totalP: this.totalPrice,
    });
    await this.onApplyCoupon();
    this.loading = false;
  }

  async onDecrease(variantProduct: any, i: number) {
    this.loading = true;
    const cart = onGetListCart();
    let variant = this.$utils.cloneDeep(variantProduct);
    if (variantProduct.quantity > 1) {
      // const findProduct = cart.find((variant:any) => variant._id === findProduct._id)
      variant.quantity -= 1;
      cart[i] = variant;
    }
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", JSON.stringify(cart));
    this.$store.commit("product/getPriceShipping", {
      listCart: this.listCart,
      totalP: this.totalPrice,
    });
    await this.onApplyCoupon();
    this.loading = false;
  }

  async onDelete(i: number) {
    this.loading = true;
    const cart = onGetListCart();
    cart.splice(i, 1);
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", JSON.stringify(cart));

    if (!this.listCart.length) {
      this.$store.commit("cart/setDrawerProduct", false);
    }
    this.$store.commit("product/getPriceShipping", {
      listCart: this.listCart,
      totalP: this.totalPrice,
    });
    await this.onApplyCoupon();
    this.loading = false;
  }

  noscriptAdsFacebook: any = [];

  adsTiktok: any = [];
  timer = "";
  onCalcTimer() {
    const that = this;
    const promotion = that.$store.state.promotion.promotion;
    if (promotion.status === 1) {
      var x = setInterval(function () {
        // Get today's date and time
        var now = new Date().getTime();
        // Find the distance between now and the count down date
        var distance = promotion.to * 1000 - now;
        // Time calculations for days, hours, minutes and seconds
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
        );
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);
        that.timer = `${
          days
            ? days < 10
              ? `0${days} ${days > 1 ? `days` : "day"} `
              : `${days} ${days > 1 ? `days` : "day"} `
            : ""
        }${hours ? (hours < 10 ? `0${hours}:` : `${hours}:`) : "00:"}${
          minutes ? (minutes < 10 ? `0${minutes}:` : `${minutes}:`) : "00:"
        }${seconds ? (seconds < 10 ? `0${seconds}` : `${seconds}`) : ""}`;
        if (distance < 0) {
          clearInterval(x);
          that.timer = "";
        }
      }, 1000);
    }
  }

  get listCart() {
    return this.$store.state.cart?.listCart || [];
  }

  get myIp() {
    return this.$store.state?.sitePage?.myIp || {};
  }

  slug = "";
  isLoadingPaypal = true;
  async mounted() {
    try {
      window.addEventListener("scroll", this.handleScroll);
      this.slug = this.$route.params.slug || "";
      this.loadScriptTwitter();
      this.loadScriptSnap();
      this.onCalcTimer();

      // Google
      const googlePlatformId = this.$store.state.setting.google.platformId;
      if (googlePlatformId) {
        const googlePixelIds = googlePlatformId
          .split("\n")
          .map((id: string) => id.trim())
          .filter((id: string) => id);
        if (googlePixelIds && googlePixelIds.length) {
          for (let id of googlePixelIds) {
            gtag(id);
          }
        }
      }
    } catch (error) {
      this.$router.push("/error");
    }
  }

  async setScriptPaypal() {
    let paypal;
    if (this.publicKeyPaypal) {
      try {
        paypal = loadScript({
          "client-id": this.publicKeyPaypal,
        }).then(() => {
          this.setLoaded();
        });
      } catch (error) {}
    }
    this.$store.commit("product/setLoadingPaypal", false);
  }
  async setLoaded() {
    const that = this;
    //@ts-ignore
    const paypal: any = window.paypal;
    let orderCodePaypal = "";
    let paymentMethodId = "";
    const domain = this.$store.state?.product?.domain || "";
    let amount = 0;
    for (let cart of this.listCart) {
      amount += cart.quantity;
    }
    //@ts-ignore
    await window.paypal
      .Buttons({
        createOrder: async function (data: any, actions: any) {
          try {
            that.$gtag.event("payment_click_paypal", {
              event_category: "click paypal",
              event_label: "click paypal",
            });
            let listSelectedProduct = [];
            if (that.listCart.length) {
              listSelectedProduct = that.listCart.map((cart: any) => ({
                variantSellerId: cart._id,
                quantity: parseInt(cart.quantity),
              }));
            }

            trackEventCheckoutInitiated(that);
            const bodyTrack = {
              productName: that.product?.productName || "",
              value: parseFloat(that.totalPrice) || 0,
            };
            trackEventAddPaymentInfo(that, bodyTrack);
            that.$gtag.event("form_submissions", {
              value: `${that.product?.productName || ""} ${
                parseFloat(that.totalPrice) || 0
              }`,
              currency: "USD",
            });
            let sessionId = getSessionId();
            if (!sessionId) {
              const charRandom = randomCharacter().toLocaleLowerCase();
              const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
              sessionId = `${charRandom}_${unixTimeStamp}`;
              setSessionId(sessionId);
            }
            const body = {
              listSelectedProduct,
              countryIp: that.myIp.countryCode,
              sessionId,
            };
            const query = that.$store.state.sitePage.utm || {};
            const response = await that.$api.cart.paypalCreateOrderDirect(
              body,
              domain,
              query
            );
            if (response && response.data) {
              paymentMethodId = response.data.paymentMethodId;
              orderCodePaypal = response.data.orderCode;
              return response.data.id;
            }
          } catch (error: any) {
            const message = error?.response?.data?.message || "";
            that.$gtag.event("purchase fail", {
              error: message,
              product_id: that.listCart[0]?._id,
              event_label: "fail paypal",
            });
            that.$sentry.captureException(
              error.response?.data || "An error occurred"
            );
            apiErrorHandler(error, that);
          }
        },
        onApprove: async function (data: any, actions: any) {
          const { paymentID, payerID } = data;
          if (!paymentID || !payerID || !paymentMethodId) return;
          const response = await that.$api.cart.completePaypalPayment({
            paymentMethodId,
            paymentID,
            payerID,
          });
          if (response.data) {
            that.$gtag.event("purchase", {
              event_label: `purchase paypal`,
              currency: "USD",
            });
            const bodyTrack = {
              quantity: amount || 1,
              total: parseFloat(that.totalPrice) || 1,
              productName: that.listCart[0]?.productName || "",
              listSelectedProduct: that.listCart.map((cart: any) => ({
                orderCode: response?.data?.orderCode || "",
                quantity: cart.quantity || 1,
                price: cart.price || 1,
              })),
              email: response?.data?.email || "",
              phoneNumber: response?.data?.phoneNumber || "",
              orderCode: response?.data?.orderCode || "",
            };
            trackEventPurchased(that, bodyTrack);
            that.$store.commit("cart/setListCart", []);
            localStorage.setItem("cart", JSON.stringify([]));
            that.$router.push(
              `/order-success?email=${
                response.data.email
              }&order_code=${response.data.orderCode.replace("#", "")}`
            );
          }
        },
        //@ts-ignore
        onCancel: async function (isFail?: boolean) {
          Swal.fire({
            title: `${that.$language.failed}`,
            text: `${that.$language.cancelSuccessfully}`,
            icon: "error",
            confirmButtonColor: "#FF5252",
            confirmButtonText: "Agree",
          });
          that.$gtag.event("cancel_click_paypal", {
            event_category: "click cancel paypal",
            event_label: "click cancel paypal",
          });
          // that.onDeleteOrder(orderCodePaypal);
        },
        //@ts-ignore
        fundingSource: that.enableCardPaypal
          ? undefined
          : paypal.FUNDING.PAYPAL,
        clientId: that.publicKeyPaypal,
      })
      //@ts-ignore
      .render(this.$refs.paypalHeader);
  }
  async onDeleteOrder(orderCodePaypal: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      await this.$api.order.deleteOrder(orderCodePaypal);
    } catch (error) {}
  }

  loadScriptTwitter() {
    const twitter = this.$store.state.setting.twitter;
    if (twitter?.platformId) {
      const {
        twitterPixelId,
        pageViewId,
        contentViewId,
        addToCartId,
        checkoutInitiatedId,
        addedPaymentInfoId,
        purchaseId,
      } = twitter.platformId;
      if (
        twitterPixelId ||
        pageViewId ||
        contentViewId ||
        addToCartId ||
        checkoutInitiatedId ||
        addedPaymentInfoId ||
        purchaseId
      ) {
        const script = document.createElement("script");
        script.innerHTML = `!function(e,t,n,s,u,a){e.twq||(s=e.twq=function(){s.exe?s.exe.apply(s,arguments):s.queue.push(arguments);
      },s.version='1.1',s.queue=[],u=t.createElement(n),u.async=!0,u.src='/js/twitter-script.js',
      a=t.getElementsByTagName(n)[0],a.parentNode.insertBefore(u,a))}(window,document,'script');
      twq('config','oejn5');`;
        document.head.appendChild(script);
        handleTwitter(this);
        if (pageViewId || contentViewId) {
          //@ts-ignore
          TwitterTracking(twq, this, "ContentView");
          //@ts-ignore
          TwitterTracking(twq, this, "PageView");
        }
      }
    }
  }

  loadScriptSnap() {
    const snap = this.$store.state.setting.snap;
    if (snap?.platformId) {
      const listSnap = snap.platformId
        .split("\n")
        .filter((item: string) => item);
      //@ts-ignore
      if (snaptr) {
        for (let item of listSnap) {
          //@ts-ignore
          snaptr("init", `${item}`);
        }
        //@ts-ignore
        snaptr("track", "PAGE_VIEW");
        //@ts-ignore
        snaptr("track", "VIEW_CONTENT");
      }
    }
  }

  get loadingPaypal() {
    return this.$store.state.product.loadingPaypal;
  }

  get publicKeyPaypal() {
    return this.$store.state.cart.publicKeyPaypal;
  }

  get enableCardPaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return listPayment[findIndex]?.isOpenPaypalCard;
    }
    return false;
  }

  get enablePaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return this.$store.state.cart?.listPayment[findIndex]?.status;
    }
    return false;
  }

  get convertImage() {
    const siteInfo = this.$store.state.setting.siteInfo;
    if (siteInfo && siteInfo.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "";
  }

  get product() {
    return this.$store.state.product?.product || {};
  }

  get logo() {
    const siteInfo = this.$store.state?.setting?.siteInfo;
    if (siteInfo?.logo?.imageUrl) {
      return `${api}/${siteInfo.logo.imageUrl}`;
    } else if (siteInfo?.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "/logous.png";
  }

  get loadingFullPage() {
    return this.$store.state.sitePage.loadingFullPage || false;
  }

  get isDonePaypalHome() {
    return this.$store.state.product?.isDonePaypalHome || false;
  }

  getNameVariant(item: any) {
    return item.listValue.join(" / ");
  }

  get domain() {
    return this.$store.state?.product?.domain || "";
  }

  async onAddToCart() {
    this.loading = true;
    await this.$store.dispatch("cart/onAddToCart", {
      ctx: this,
      variantId: this.variantId,
      product: this.product,
      quantityProduct: this.quantityProduct,
      domain: this.domain,
    });
    await this.onApplyCoupon();
    this.$store.commit("cart/setDrawerProduct", true);
    this.loading = false;
  }

  handleScroll() {
    const targetElement = document.getElementById(
      "imageFluid-product-description"
    );
    if (targetElement) {
      const scrollPosition = window.scrollY;
      //@ts-ignore
      const elementOffset = targetElement.offsetTop;
      const offsetThreshold = 100;

      if (scrollPosition >= elementOffset - offsetThreshold) {
        //@ts-ignore
        document.getElementById("cart-fixed-bottom").classList.add("d-block");
        //@ts-ignore
        document.getElementById("cart-fixed-bottom").classList.remove("d-none");
      } else {
        //@ts-ignore
        document.getElementById("cart-fixed-bottom").classList.add("d-none");
        //@ts-ignore
        document
          .getElementById("cart-fixed-bottom")
          .classList.remove("d-block");
      }
    }
  }

  @Watch("$route.path")
  changedPath() {
    this.loading = false;
  }

  @Watch("drawerProduct")
  async changedDrawer(value: boolean) {
    if (value) {
      this.loading = true;
      this.$store.commit("product/getPriceShipping", {
        listCart: this.listCart,
        totalP: this.totalPrice,
      });
      await this.onApplyCoupon();
      this.loading = false;
    }
  }
  countPaypal = 1;
  @Watch("isDonePaypalHome")
  changed(value: boolean) {
    if (value && this.countPaypal === 1) {
      setTimeout(() => {
        this.setScriptPaypal().then(() => {
          this.isLoadingPaypal = false;
          this.countPaypal += 1;
        });
      }, 500);
    }
  }
}
</script>
<style lang="scss" scoped>
.checkout-text-btn {
  font-size: clamp(12px, 1.5vw, 16px);
  line-height: 150%;
}
.menu {
  position: fixed;
  bottom: 2rem;
  right: 1.5rem;

  .background-cart {
    border-radius: 50%;
    padding: 24px 14px;
    width: 52px;
    height: 54px;
    background: black;
    position: relative;

    .total {
      position: absolute;
      top: -12px;
      right: -12px;
      width: 34px;
      height: 34px;
      border-radius: 50%;
      border: 4px solid #fff;
      display: flex;
      justify-content: center;
      align-items: center;
      background: #f14668 !important;
      font-weight: 700;
      font-size: 12px;
      color: white;
    }
  }
  @media screen and (max-width: 600px) {
    bottom: 10rem;
  }
}
</style>
